"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.send = void 0;
const promises_1 = require("fs/promises");
const handlebars_1 = require("handlebars");
const html_to_text_1 = require("html-to-text");
const nodemailer_1 = __importDefault(require("nodemailer"));
const path_1 = require("path");
const send = (_a) => __awaiter(void 0, void 0, void 0, function* () {
    var { template, values, from = process.env.MAIL_FROM || process.env.MAIL_USER } = _a, envelope = __rest(_a, ["template", "values", "from"]);
    const transport = {
        host: process.env.MAIL_HOST,
        port: (process.env.MAIL_PORT || 587),
        secure: Boolean(process.env.MAIL_SECURE || false),
        auth: {
            user: process.env.MAIL_USER,
            pass: process.env.MAIL_PASSWORD,
        },
    };
    try {
        const tpl = yield (0, promises_1.readFile)((0, path_1.resolve)(process.cwd(), template), 'utf-8');
        const html = (0, handlebars_1.compile)(tpl)(values);
        const result = yield nodemailer_1.default.createTransport(transport).sendMail(Object.assign(Object.assign({}, envelope), { from,
            html, text: (0, html_to_text_1.convert)(html) }));
        return result;
    }
    catch (err) {
        throw err;
    }
});
exports.send = send;
//# sourceMappingURL=mailer.js.map